<template>
<div class=" container-fluid" style="overflow:hidden">
  <navbar id="nav"></navbar>
  <div class="">
    <template>

      <router-view class="content" style="overflow:hidden">
      </router-view>
      <modal
      name="modalReading"
      width="100%"
      height="100%"
      clickToClose
      >
        <div class="modal-container">
          <div class="modal-header">
            <h3>
              {{title}}
            </h3>
                <button type="button" class="close"  @click="$modal.hide('modalReading')" data-dismiss="modal" aria-label="Close">
                    <font-awesome-icon color="firebrick" icon="times" size="lg"/>
                </button>
          </div>
        <div class="modal-body">
          <bookRender @updateProgress="progress=>{updateProgress(progress)}"></bookRender>
        </div>
        </div>
      </modal>
    </template>
  </div>
  </div>
</template>

<script>
const $ = require("jquery");
import navbar from "./components/NavBar";
import bookRender from "./components/user_board/BookRender";
import EventBus from "./main";
export default {
  name: "App",
  components: {
    navbar,
    bookRender
  },
  data() {
    return {
      book: null,
      readingBook:false,
      title:null,
    };
  },
  mounted() {
    $('[data-toggle="popover"]').popover();
    EventBus.$on("openBook", data => {
      this.$socket.emit("reqBook",  data.require );
      this.readingBook=true;
      this.title=data.book.title;
      this.book=data.book
      this.$modal.show('modalReading');
    });

    this.$socket.on('resDownloadBook', (response)=>{
      var a = document.createElement("a");
      document.body.appendChild(a);
      a.style = "display: none";
      var blob = new File([response.book], response.fileName);
      var url = window.URL.createObjectURL(blob);
      a.href = url;
      a.download = blob.name;
      a.click();
      window.URL.revokeObjectURL(url);

    })
  },
  methods:{
    hide (){
       this.$modal.hide('modalReading');
    },
    updateProgress(progress){
      EventBus.$emit('updateBookProgress'+this.book._id,progress)
    }
  }
};
</script>

<style>

.content {
  overflow: hidden;
  position: relative;
  width: 100%;
  height: 100% !important;

}
html {
  height: 100%;

}
body {
    height: 100%;
    background-color: #F7F9F9
}

#nav {
  z-index: 100;
  background-color: white;
}

.input-border-less {
  border-width: 0px !important;
  border-bottom-width: 1px !important;
  outline: 0px !important;
}
.input-border-less:focus {
  border-bottom-width: 2px !important;
  box-shadow: 0 4px 2px -4px blue !important;
}

.input.is--invalid {
  border-width: 0px !important;
  border-bottom-width: 2px !important;
  outline: 0px !important;
  box-shadow: 0 4px 2px -4px firebrick !important;
}
#w-100{
  width: 100% !important;
}
.app{
  position: absolute;
  width: 100%;
  min-height: 100% !important;
}
</style>
